## yaramod 3.6.0

=== CMakeLists.txt ===
##
## CMake build script for the yaramod.
##

cmake_minimum_required(VERSION 3.6)
project(yaramod CXX)

# Configurable options.
option(YARAMOD_TESTS    "Build tests for yaramod" OFF)
option(YARAMOD_DOCS     "Build doxygen documentation for yaramod" OFF)
option(YARAMOD_PYTHON   "Build Python extension" OFF)
option(YARAMOD_EXAMPLES "Build examples" OFF)

# Requirements.
include(GNUInstallDirs)
if(YARAMOD_DOC)
	find_package(Doxygen)
endif()

# Variables.
set(YARAMOD_DOC_DIR     "${PROJECT_SOURCE_DIR}/doc")
set(YARAMOD_SRC_DIR     "${PROJECT_SOURCE_DIR}/src")
set(YARAMOD_INCLUDE_DIR "${PROJECT_SOURCE_DIR}/include")
set(YARAMOD_SRC_BIN_DIR "${PROJECT_BINARY_DIR}/src")
set(YARAMOD_DEPS_DIR    "${PROJECT_SOURCE_DIR}/deps")

# Use C++17.
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS ON)

# Enable all compiler warnings.
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")
endif()

# Always build position independent code.
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# Subdirectories.
add_subdirectory(deps)
add_subdirectory(src)
if(YARAMOD_TESTS)
	add_subdirectory(tests)
endif()
if(YARAMOD_DOCS)
	add_subdirectory(docs)
endif()

=== requirements.txt ===
pytest>=4.2.0,<5.0.0
pypandoc>=1.4

=== deps/CMakeLists.txt ===
if(YARAMOD_TESTS)
	add_subdirectory(googletest)
endif()
if(YARAMOD_PYTHON)
	add_subdirectory(pybind11)
endif()

set(POG_BUNDLED_FMT ON CACHE BOOL "Use bundled fmt" FORCE)
set(POG_BUNDLED_RE2 ON CACHE BOOL "Use bundled re2" FORCE)
set(POG_PIC         ON CACHE BOOL "Build PIC"       FORCE)

add_subdirectory(pog)

=== src/CMakeLists.txt ===
##
## CMake build script for the yaramod library.
##

# Source files.
set(SOURCES
	builder/yara_expression_builder.cpp
	builder/yara_file_builder.cpp
	builder/yara_hex_string_builder.cpp
	builder/yara_rule_builder.cpp
	parser/parser_driver.cpp
	types/hex_string.cpp
	types/literal.cpp
	types/meta.cpp
	types/modules/androguard_module.cpp
	types/modules/cuckoo_module.cpp
	types/modules/dex_module.cpp
	types/modules/dotnet_module.cpp
	types/modules/elf_module.cpp
	types/modules/hash_module.cpp
	types/modules/macho_module.cpp
	types/modules/magic_module.cpp
	types/modules/math_module.cpp
	types/modules/module.cpp
	types/modules/pe_module.cpp
	types/modules/phish_module.cpp
	types/modules/time_module.cpp
	types/modules/metadata_module.cpp
	types/plain_string.cpp
	types/rule.cpp
	types/token.cpp
	types/token_stream.cpp
	types/yara_file.cpp
	utils/filesystem.cpp
	utils/utils.cpp
	yaramod.cpp
)

## Compile parser_driver.cpp with /bigobj because it generates too many sections
if(MSVC)
	set_source_files_properties(parser/parser_driver.cpp PROPERTIES COMPILE_FLAGS /bigobj)
endif()

if(NOT TARGET yaramod)
	# Library.
	add_library(yaramod ${SOURCES})

	# Library includes and interface.
	target_include_directories(yaramod PRIVATE "${YARAMOD_INCLUDE_DIR}")
	target_include_directories(yaramod SYSTEM INTERFACE "${YARAMOD_INCLUDE_DIR}")
	# We need to be able to include the generated files from the build directory.
	# By declaring the include path as a system path, we automatically discard
	# warnings from the generated header files, which is useful.
	target_include_directories(yaramod SYSTEM PUBLIC "${CMAKE_CURRENT_BINARY_DIR}")
	target_include_directories(yaramod SYSTEM PUBLIC "${YARAMOD_DEPS_DIR}")

	# Platform dependant defines.
	if(WIN32)
		target_compile_definitions(yaramod PRIVATE -DYARAMOD_OS_WINDOWS)
	elseif(UNIX)
		target_compile_definitions(yaramod PRIVATE -DYARAMOD_OS_LINUX)
	endif()

	# Linking.
	if(WIN32)
		target_link_libraries(yaramod shlwapi)
	endif()

	# Pog library
	target_link_libraries(yaramod pog)

	# Python module.
	if(YARAMOD_PYTHON)
		add_subdirectory(python)
	endif()

	# Examples.
	if(YARAMOD_EXAMPLES)
		add_subdirectory(examples)
	endif()

	# Installation.
	install(
		TARGETS yaramod
		ARCHIVE DESTINATION "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}"
		LIBRARY DESTINATION "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}"
	)
	install(
		DIRECTORY "${YARAMOD_INCLUDE_DIR}/"
		DESTINATION "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR}"
	)
	install(
		DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/yaramod/"
		DESTINATION "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR}/yaramod"
		FILES_MATCHING
			PATTERN "*.hpp"
			PATTERN "*.hh"
	)
endif()

=== deps/googletest/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

find_package(Threads REQUIRED)

include(ExternalProject)

if(CMAKE_C_COMPILER)
	set(CMAKE_C_COMPILER_OPTION "-DCMAKE_C_COMPILER=${CMAKE_C_COMPILER}")
endif()
if(CMAKE_CXX_COMPILER)
	set(CMAKE_CXX_COMPILER_OPTION "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}")
endif()

ExternalProject_Add(googletest
	URL https://github.com/google/googletest/archive/dc1ca9ae4c206434e450ed4ff535ca7c20c79e3c.zip
	URL_HASH SHA256=d8376d6283e15ffd317646052233c88e2044cd61453619315e6fc139dc1b5d76
	CMAKE_ARGS
		# This does not work on MSVC, but is useful on Linux.
		-DCMAKE_BUILD_TYPE=Release
		# Without this, googletest's CMakeLists.txt replaces "/MD" (dynamic run-time) with "-MT" (static runtime).
		# Default config for most applications is "/MD", so this will cause problems if linked with "-MT" googletest.
		# https://msdn.microsoft.com/en-us/library/2kzt1wy3.aspx
		-Dgtest_force_shared_crt=ON
		# Force the use of the same compiler as used to build the top-level
		# project. Otherwise, the external project may pick up a different
		# compiler, which may result in link errors.
		"${CMAKE_C_COMPILER_OPTION}"
		"${CMAKE_CXX_COMPILER_OPTION}"
	# Disable the update step.
	UPDATE_COMMAND ""
	# Disable the install step.
	INSTALL_COMMAND ""
	LOG_DOWNLOAD ON
	LOG_CONFIGURE ON
	LOG_BUILD ON
)

# Set include directories.
ExternalProject_Get_Property(googletest source_dir)
set(GTEST_INCLUDE_DIR ${source_dir}/googletest/include)
set(GMOCK_INCLUDE_DIR ${source_dir}/googlemock/include)

# Add libraries.
ExternalProject_Get_Property(googletest binary_dir)

if(MSVC)
	set(DEBUG_DIR "Debug/")
	set(RELEASE_DIR "Release/")
	set(DEBUG_LIB_SUFFIX "d")
endif()

add_library(gtest INTERFACE)
target_link_libraries(gtest INTERFACE debug ${binary_dir}/lib/${DEBUG_DIR}${CMAKE_STATIC_LIBRARY_PREFIX}gtest${DEBUG_LIB_SUFFIX}${CMAKE_STATIC_LIBRARY_SUFFIX} Threads::Threads)
target_link_libraries(gtest INTERFACE optimized ${binary_dir}/lib/${RELEASE_DIR}${CMAKE_STATIC_LIBRARY_PREFIX}gtest${CMAKE_STATIC_LIBRARY_SUFFIX} Threads::Threads)
target_include_directories(gtest SYSTEM INTERFACE ${GTEST_INCLUDE_DIR})
add_dependencies(gtest googletest)

add_library(gtest_main INTERFACE)
target_link_libraries(gtest_main INTERFACE debug ${binary_dir}/lib/${DEBUG_DIR}${CMAKE_STATIC_LIBRARY_PREFIX}gtest_main${DEBUG_LIB_SUFFIX}${CMAKE_STATIC_LIBRARY_SUFFIX} Threads::Threads)
target_link_libraries(gtest_main INTERFACE optimized ${binary_dir}/lib/${RELEASE_DIR}${CMAKE_STATIC_LIBRARY_PREFIX}gtest_main${CMAKE_STATIC_LIBRARY_SUFFIX} Threads::Threads)
target_link_libraries(gtest_main INTERFACE gtest)
target_include_directories(gtest_main SYSTEM INTERFACE ${GTEST_INCLUDE_DIR})
add_dependencies(gtest_main googletest)

add_library(gmock INTERFACE)
target_link_libraries(gmock INTERFACE debug ${binary_dir}/lib/${DEBUG_DIR}${CMAKE_STATIC_LIBRARY_PREFIX}gmock${DEBUG_LIB_SUFFIX}${CMAKE_STATIC_LIBRARY_SUFFIX} Threads::Threads)
target_link_libraries(gmock INTERFACE optimized ${binary_dir}/lib/${RELEASE_DIR}${CMAKE_STATIC_LIBRARY_PREFIX}gmock${CMAKE_STATIC_LIBRARY_SUFFIX} Threads::Threads)
target_link_libraries(gmock INTERFACE gtest)
target_include_directories(gmock SYSTEM INTERFACE ${GTEST_INCLUDE_DIR} ${GMOCK_INCLUDE_DIR})
add_dependencies(gmock googletest)

add_library(gmock_main INTERFACE)
target_link_libraries(gmock_main INTERFACE debug ${binary_dir}/lib/${DEBUG_DIR}${CMAKE_STATIC_LIBRARY_PREFIX}gmock_main${DEBUG_LIB_SUFFIX}${CMAKE_STATIC_LIBRARY_SUFFIX} Threads::Threads)
target_link_libraries(gmock_main INTERFACE optimized ${binary_dir}/lib/${RELEASE_DIR}${CMAKE_STATIC_LIBRARY_PREFIX}gmock_main${CMAKE_STATIC_LIBRARY_SUFFIX} Threads::Threads)
target_link_libraries(gmock_main INTERFACE gmock)
target_include_directories(gmock_main SYSTEM INTERFACE ${GTEST_INCLUDE_DIR} ${GMOCK_INCLUDE_DIR})
add_dependencies(gmock_main googletest)

=== docs/doxygen/CMakeLists.txt ===
##
## CMake build script for the yaramod documentation.
##

add_custom_target(doc
	WORKING_DIRECTORY "${YARAMOD_DOC_DIR}"
	COMMAND ${DOXYGEN_EXECUTABLE}
	COMMENT "Generating doxygen documentation"
)

=== docs/rtd/requirements.txt ===
Sphinx>=2.4.2,<2.5.0
sphinx_rtd_theme>=0.4.3,<0.5.0
sphinx-tabs>=1.1.13,<1.2.0

=== src/python/CMakeLists.txt ===
pybind11_add_module(yaramod-python
	yaramod_python.cpp
	py_visitor.cpp
)

# We need to build python extension with -O1 when using GCC because
# there is some problem with linking std::shared_ptr<BoolLiteralExpression>:
#
# undefined reference to `vtable for std::_Sp_counted_ptr_inplace<yaramod::BoolLiteralExpression, std::allocator<yaramod::BoolLiteralExpression>, (__gnu_cxx::_Lock_policy)2>'
#
# It seems like -O2 and -O3 produce some kind of different template instantiation which is not compatible
# with other compiler options use when compiling python extension.
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
	set(CMAKE_CXX_FLAGS_RELEASE "-O1 -DNDEBUG")
endif()

set_target_properties(yaramod-python PROPERTIES OUTPUT_NAME "yaramod")
target_link_libraries(yaramod-python PUBLIC yaramod)

=== tests/cpp/CMakeLists.txt ===
##
## CMake build script for the yaramod tests.
##

# Source files.
set(SOURCES
	tokenstream_tests.cpp
	representation_tests.cpp
	builder_tests.cpp
	parser_tests.cpp
	trie_tests.cpp
	utils_tests.cpp
	yaramod_tests.cpp
)

if(NOT TARGET yaramod_tests)
	# Executable.
	add_executable(yaramod_tests ${SOURCES})

	# Linking.
	target_link_libraries(yaramod_tests yaramod gtest gtest_main)

	# Includes.
	target_include_directories(yaramod_tests PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}")
endif()

=== deps/pog/deps/CMakeLists.txt ===
if(POG_BUNDLED_RE2)
	add_subdirectory(re2)
endif()
if(POG_BUNDLED_FMT)
	add_subdirectory(fmt)
endif()

=== deps/pog/deps/fmt/CMakeLists.txt ===
include(GNUInstallDirs)
include(ExternalProject)

set(FMT_INSTALL_DIR             ${CMAKE_CURRENT_BINARY_DIR}/fmt)
set(FMT_INCLUDE_DIR             ${FMT_INSTALL_DIR}/include)
set(FMT_INSTALLED_LIBRARY       ${FMT_INSTALL_DIR}/${CMAKE_INSTALL_LIBDIR}/${CMAKE_STATIC_LIBRARY_PREFIX}fmt${CMAKE_STATIC_LIBRARY_SUFFIX})
set(FMT_INSTALLED_LIBRARY_DEBUG ${FMT_INSTALL_DIR}/${CMAKE_INSTALL_LIBDIR}/${CMAKE_STATIC_LIBRARY_PREFIX}fmtd${CMAKE_STATIC_LIBRARY_SUFFIX})
set(FMT_LIBRARY                 ${FMT_INSTALL_DIR}/${CMAKE_INSTALL_LIBDIR}/${CMAKE_STATIC_LIBRARY_PREFIX}pog_fmt${CMAKE_STATIC_LIBRARY_SUFFIX})

if(MSVC)
	set(FMT_BUILD_COMMAND ${CMAKE_COMMAND} --build . --config $<CONFIG> -- -m)
	set(FMT_INSTALL_COMMAND ${CMAKE_COMMAND} --build . --target install --config $<CONFIG>)
else()
	set(FMT_BUILD_COMMAND ${CMAKE_COMMAND} --build . -- -j)
	set(FMT_INSTALL_COMMAND ${CMAKE_COMMAND} --build . --target install)
endif()

ExternalProject_Add(
	fmt-dep
	PREFIX "fmt"
	SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/fmt"
	CMAKE_ARGS
		-DCMAKE_INSTALL_PREFIX=${FMT_INSTALL_DIR}
		-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}
		-DCMAKE_CXX_FLAGS=${CMAKE_CXX_FLAGS}
		-DCMAKE_CXX_FLAGS_RELEASE=${CMAKE_CXX_FLAGS_RELEASE}
		-DCMAKE_POSITION_INDEPENDENT_CODE=${POG_PIC}
		-DFMT_TEST=OFF
		-DFMT_DOC=OFF
	BUILD_COMMAND
		${FMT_BUILD_COMMAND}
	INSTALL_COMMAND
		${FMT_INSTALL_COMMAND}
)

ExternalProject_Add_Step(
	fmt-dep rename
	DEPENDEES install
	COMMAND ${CMAKE_COMMAND} -E rename $<IF:$<CONFIG:Debug>,${FMT_INSTALLED_LIBRARY_DEBUG},${FMT_INSTALLED_LIBRARY}> ${FMT_LIBRARY}
)

add_library(fmt::fmt STATIC IMPORTED GLOBAL)
set_target_properties(fmt::fmt PROPERTIES
	INTERFACE_INCLUDE_DIRECTORIES "${FMT_INCLUDE_DIR}"
	IMPORTED_LOCATION "${FMT_LIBRARY}"
)
add_dependencies(fmt::fmt fmt-dep)

install(
	FILES ${FMT_LIBRARY}
	DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}
)
install(
	DIRECTORY ${FMT_INCLUDE_DIR}/fmt/
	DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR}/pog/fmt
)

=== deps/pog/deps/re2/CMakeLists.txt ===
include(ExternalProject)

include(GNUInstallDirs)

set(RE2_INSTALL_DIR       ${CMAKE_CURRENT_BINARY_DIR}/re2)
set(RE2_INCLUDE_DIR       ${RE2_INSTALL_DIR}/include)
set(RE2_INSTALLED_LIBRARY ${RE2_INSTALL_DIR}/${CMAKE_INSTALL_LIBDIR}/${CMAKE_STATIC_LIBRARY_PREFIX}re2${CMAKE_STATIC_LIBRARY_SUFFIX})
set(RE2_LIBRARY           ${RE2_INSTALL_DIR}/${CMAKE_INSTALL_LIBDIR}/${CMAKE_STATIC_LIBRARY_PREFIX}pog_re2${CMAKE_STATIC_LIBRARY_SUFFIX})

if(MSVC)
	set(RE2_BUILD_COMMAND ${CMAKE_COMMAND} --build . --config $<CONFIG> -- -m)
	set(RE2_INSTALL_COMMAND ${CMAKE_COMMAND} --build . --target install --config $<CONFIG>)
else()
	set(RE2_BUILD_COMMAND ${CMAKE_COMMAND} --build . -- -j)
	set(RE2_INSTALL_COMMAND ${CMAKE_COMMAND} --build . --target install)
endif()

ExternalProject_Add(
	re2-dep
	PREFIX "re2"
	SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/re2"
	CMAKE_ARGS
		-DCMAKE_INSTALL_PREFIX=${RE2_INSTALL_DIR}
		-DCMAKE_POSITION_INDEPENDENT_CODE=${POG_PIC}
		-DCMAKE_BUILD_TYPE=Release
		-DCMAKE_CXX_FLAGS=${CMAKE_CXX_FLAGS}
		-DCMAKE_CXX_FLAGS_RELEASE=${CMAKE_CXX_FLAGS_RELEASE}
		-DRE2_BUILD_TESTING=OFF
	BUILD_COMMAND
		${RE2_BUILD_COMMAND}
	INSTALL_COMMAND
		${RE2_INSTALL_COMMAND}
)

ExternalProject_Add_Step(
	re2-dep rename
	DEPENDEES install
	COMMAND ${CMAKE_COMMAND} -E rename ${RE2_INSTALLED_LIBRARY} ${RE2_LIBRARY}
)

add_library(re2::re2 STATIC IMPORTED GLOBAL)
set_target_properties(re2::re2 PROPERTIES
	INTERFACE_INCLUDE_DIRECTORIES "${RE2_INCLUDE_DIR}"
	IMPORTED_LOCATION "${RE2_LIBRARY}"
)
target_link_libraries(re2::re2 INTERFACE Threads::Threads)
add_dependencies(re2::re2 re2-dep)

install(
	FILES ${RE2_LIBRARY}
	DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}
)
install(
	DIRECTORY ${RE2_INCLUDE_DIR}/re2/
	DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR}/pog/re2
)

=== debian/changelog ===
yaramod (3.6.0-1) unstable; urgency=medium

  * New upstream release

 -- Yangfl <mmyangfl@gmail.com>  Sat, 18 Jul 2020 16:32:07 +0800

yaramod (3.5.0-1) unstable; urgency=medium

  * Initial release

 -- Yangfl <mmyangfl@gmail.com>  Thu, 25 Jun 2020 12:38:13 +0800

=== debian/control ===
Source: yaramod
Section: libs
Priority: optional
Maintainer: Yangfl <mmyangfl@gmail.com>
Build-Depends:
 debhelper-compat (= 13),
Build-Depends-Arch:
 pkg-kde-tools,
 cmake (>= 3.6),
 pkg-config,
 libpog-dev,
 libgtest-dev,
 dh-sequence-python3,
 pybind11-dev,
 python3-dev,
 python3-setuptools,
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://github.com/avast/yaramod
Vcs-Git: https://salsa.debian.org/yangfl-guest/yaramod.git
Vcs-Browser: https://salsa.debian.org/yangfl-guest/yaramod

Package: libyaramod-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libyaramod0 (= ${binary:Version}),
 libpog-dev,
 ${misc:Depends},
Description: YARA parser for C++ (development headers)
 yaramod is a library that provides parsing of YARA rules into AST and a C++
 programming interface to build new YARA rulesets. yaramod also comes with
 Python bindings and can be installed using pip.
 .
 This package contains the development headers.

Package: libyaramod0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: YARA parser for C++
 yaramod is a library that provides parsing of YARA rules into AST and a C++
 programming interface to build new YARA rulesets. yaramod also comes with
 Python bindings and can be installed using pip.
 .
 This package contains the library.

Package: python3-yaramod
Section: python
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}
Provides: ${python3:Provides}
X-Python3-Version: ${python3:Versions}
Description: YARA parser for C++ (Python 3 binding)
 yaramod is a library that provides parsing of YARA rules into AST and a C++
 programming interface to build new YARA rulesets. yaramod also comes with
 Python bindings and can be installed using pip.
 .
 This package contains the Python 3 binding.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND =

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk

export PYBUILD_SYSTEM = distutils


%:
	dh $@

override_dh_auto_clean-arch:
	-dh_auto_clean -a -O--buildsystem=cmake
	-dh_auto_clean -a -O--buildsystem=pybuild
	rm -rf yaramod.egg-info

YARAMOD_TESTS = OFF
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
  YARAMOD_TESTS = ON
endif

override_dh_auto_configure-arch:
	dh_auto_configure -a -O--buildsystem=cmake -- \
		-DYARAMOD_VERSION=$(DEB_VERSION_UPSTREAM) \
		-DPYTHON_EXECUTABLE=/usr/bin/python3 \
		-DYARAMOD_TESTS=$(YARAMOD_TESTS) -DYARAMOD_PYTHON=ON -DCMAKE_STRIP=OFF
	dh_auto_configure -a -O--buildsystem=pybuild

override_dh_auto_build-arch:
	dh_auto_build -a -O--buildsystem=cmake
	cp obj-$(DEB_HOST_GNU_TYPE)/src/python/yaramod.cpython-*.so .pybuild/cpython3_*/build/
	dh_auto_build -a -O--buildsystem=pybuild

override_dh_auto_test-arch:
	./obj-$(DEB_HOST_GNU_TYPE)/tests/cpp/yaramod_tests
	# tests.python.test_parser.ParserTests bug
	LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/src:$$LD_LIBRARY_PATH dh_auto_test -a -O--buildsystem=pybuild

override_dh_auto_install-arch:
	dh_auto_install -a -O--buildsystem=cmake
	dh_auto_install -a -O--buildsystem=pybuild

## yaramod 3.21.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,18 +11,43 @@
 option(YARAMOD_PYTHON   "Build Python extension" OFF)
 option(YARAMOD_EXAMPLES "Build examples" OFF)
 
+# Add CMake module path.
+list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")
+
 # Requirements.
 include(GNUInstallDirs)
 if(YARAMOD_DOC)
 	find_package(Doxygen)
 endif()
+find_package(Filesystem)
 
 # Variables.
 set(YARAMOD_DOC_DIR     "${PROJECT_SOURCE_DIR}/doc")
 set(YARAMOD_SRC_DIR     "${PROJECT_SOURCE_DIR}/src")
 set(YARAMOD_INCLUDE_DIR "${PROJECT_SOURCE_DIR}/include")
+set(YARAMOD_SCRIPTS_DIR "${PROJECT_SOURCE_DIR}/scripts")
 set(YARAMOD_SRC_BIN_DIR "${PROJECT_BINARY_DIR}/src")
 set(YARAMOD_DEPS_DIR    "${PROJECT_SOURCE_DIR}/deps")
+set(YARAMOD_MODULES_DIR     "${PROJECT_SOURCE_DIR}/modules")
+set(YARAMOD_MODULES_GENERATED_DIR     "${YARAMOD_INCLUDE_DIR}/yaramod/types/modules/generated")
+set(WRAP_MODULE_SOURCES
+	${YARAMOD_MODULES_GENERATED_DIR}/module_console_generated.h
+	${YARAMOD_MODULES_GENERATED_DIR}/module_cuckoo_deprecated_generated.h
+	${YARAMOD_MODULES_GENERATED_DIR}/module_cuckoo_generated.h
+	${YARAMOD_MODULES_GENERATED_DIR}/module_dex_generated.h
+	${YARAMOD_MODULES_GENERATED_DIR}/module_dotnet_generated.h
+	${YARAMOD_MODULES_GENERATED_DIR}/module_elf_generated.h
+	${YARAMOD_MODULES_GENERATED_DIR}/module_hash_generated.h
+	${YARAMOD_MODULES_GENERATED_DIR}/module_list.h
+	${YARAMOD_MODULES_GENERATED_DIR}/module_macho_generated.h
+	${YARAMOD_MODULES_GENERATED_DIR}/module_magic_generated.h
+	${YARAMOD_MODULES_GENERATED_DIR}/module_math_generated.h
+	${YARAMOD_MODULES_GENERATED_DIR}/module_pe_generated.h
+	${YARAMOD_MODULES_GENERATED_DIR}/module_string_generated.h
+	${YARAMOD_MODULES_GENERATED_DIR}/module_time_generated.h
+)
+
+file(MAKE_DIRECTORY ${YARAMOD_MODULES_GENERATED_DIR})
 
 # Use C++17.
 set(CMAKE_CXX_STANDARD 17)
@@ -46,3 +71,23 @@
 if(YARAMOD_DOCS)
 	add_subdirectory(docs)
 endif()
+
+# Command that creates files in ${WRAP_MODULE_SOURCES}
+# simple call python won't work on macOS 12.3+
+# See: https://developer.apple.com/documentation/macos-release-notes/macos-12_3-release-notes#Python
+find_package(Python REQUIRED COMPONENTS Interpreter)
+add_custom_command(
+	OUTPUT ${WRAP_MODULE_SOURCES}
+	# Create .h modules from .json modules
+	COMMAND	${Python_EXECUTABLE} ${YARAMOD_SCRIPTS_DIR}/json_to_array.py -i "${YARAMOD_MODULES_DIR}" -o "${YARAMOD_MODULES_GENERATED_DIR}"
+	COMMENT
+		"Converting yaramod modules from JSON to byte arrays in .cpp files"
+)
+
+# Target depending on creation of modules ${WRAP_MODULE_SOURCES} by the command 
+add_custom_target(modules_wrapping ALL
+	DEPENDS
+		${WRAP_MODULE_SOURCES}
+	VERBATIM
+)
+add_dependencies(yaramod modules_wrapping)

=== requirements.txt ===
pytest>=4.2.0,<5.0.0
pypandoc>=1.4
setuptools>=62.4.0

=== deps/CMakeLists.txt ===
--- 
+++ 
@@ -9,4 +9,5 @@
 set(POG_BUNDLED_RE2 ON CACHE BOOL "Use bundled re2" FORCE)
 set(POG_PIC         ON CACHE BOOL "Build PIC"       FORCE)
 
+add_subdirectory(json)
 add_subdirectory(pog)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -12,26 +12,17 @@
 	types/hex_string.cpp
 	types/literal.cpp
 	types/meta.cpp
-	types/modules/androguard_module.cpp
-	types/modules/cuckoo_module.cpp
-	types/modules/dex_module.cpp
-	types/modules/dotnet_module.cpp
-	types/modules/elf_module.cpp
-	types/modules/hash_module.cpp
-	types/modules/macho_module.cpp
-	types/modules/magic_module.cpp
-	types/modules/math_module.cpp
+	types/variable.cpp
 	types/modules/module.cpp
-	types/modules/pe_module.cpp
-	types/modules/phish_module.cpp
-	types/modules/time_module.cpp
-	types/modules/metadata_module.cpp
+	types/modules/module_pool.cpp
 	types/plain_string.cpp
 	types/rule.cpp
+	types/sections_summary.cpp
 	types/token.cpp
 	types/token_stream.cpp
 	types/yara_file.cpp
-	utils/filesystem.cpp
+	utils/json.cpp
+	utils/filesystem_operations.cpp
 	utils/utils.cpp
 	yaramod.cpp
 )
@@ -69,6 +60,9 @@
 	# Pog library
 	target_link_libraries(yaramod pog)
 
+	# Filesystem library.
+	target_link_libraries(yaramod Filesystem::Filesystem)
+
 	# Python module.
 	if(YARAMOD_PYTHON)
 		add_subdirectory(python)

=== deps/googletest/CMakeLists.txt ===
--- 
+++ 
@@ -12,8 +12,8 @@
 endif()
 
 ExternalProject_Add(googletest
-	URL https://github.com/google/googletest/archive/dc1ca9ae4c206434e450ed4ff535ca7c20c79e3c.zip
-	URL_HASH SHA256=d8376d6283e15ffd317646052233c88e2044cd61453619315e6fc139dc1b5d76
+	URL https://github.com/google/googletest/archive/58d77fa8070e8cec2dc1ed015d66b454c8d78850.zip
+	URL_HASH SHA256=ab78fa3f912d44d38b785ec011a25f26512aaedc5291f51f3807c592b506d33a
 	CMAKE_ARGS
 		# This does not work on MSVC, but is useful on Linux.
 		-DCMAKE_BUILD_TYPE=Release
@@ -50,27 +50,27 @@
 endif()
 
 add_library(gtest INTERFACE)
-target_link_libraries(gtest INTERFACE debug ${binary_dir}/lib/${DEBUG_DIR}${CMAKE_STATIC_LIBRARY_PREFIX}gtest${DEBUG_LIB_SUFFIX}${CMAKE_STATIC_LIBRARY_SUFFIX} Threads::Threads)
+target_link_libraries(gtest INTERFACE debug ${binary_dir}/lib/${DEBUG_DIR}${CMAKE_STATIC_LIBRARY_PREFIX}gtest${CMAKE_STATIC_LIBRARY_SUFFIX} Threads::Threads)
 target_link_libraries(gtest INTERFACE optimized ${binary_dir}/lib/${RELEASE_DIR}${CMAKE_STATIC_LIBRARY_PREFIX}gtest${CMAKE_STATIC_LIBRARY_SUFFIX} Threads::Threads)
 target_include_directories(gtest SYSTEM INTERFACE ${GTEST_INCLUDE_DIR})
 add_dependencies(gtest googletest)
 
 add_library(gtest_main INTERFACE)
-target_link_libraries(gtest_main INTERFACE debug ${binary_dir}/lib/${DEBUG_DIR}${CMAKE_STATIC_LIBRARY_PREFIX}gtest_main${DEBUG_LIB_SUFFIX}${CMAKE_STATIC_LIBRARY_SUFFIX} Threads::Threads)
+target_link_libraries(gtest_main INTERFACE debug ${binary_dir}/lib/${DEBUG_DIR}${CMAKE_STATIC_LIBRARY_PREFIX}gtest_main${CMAKE_STATIC_LIBRARY_SUFFIX} Threads::Threads)
 target_link_libraries(gtest_main INTERFACE optimized ${binary_dir}/lib/${RELEASE_DIR}${CMAKE_STATIC_LIBRARY_PREFIX}gtest_main${CMAKE_STATIC_LIBRARY_SUFFIX} Threads::Threads)
 target_link_libraries(gtest_main INTERFACE gtest)
 target_include_directories(gtest_main SYSTEM INTERFACE ${GTEST_INCLUDE_DIR})
 add_dependencies(gtest_main googletest)
 
 add_library(gmock INTERFACE)
-target_link_libraries(gmock INTERFACE debug ${binary_dir}/lib/${DEBUG_DIR}${CMAKE_STATIC_LIBRARY_PREFIX}gmock${DEBUG_LIB_SUFFIX}${CMAKE_STATIC_LIBRARY_SUFFIX} Threads::Threads)
+target_link_libraries(gmock INTERFACE debug ${binary_dir}/lib/${DEBUG_DIR}${CMAKE_STATIC_LIBRARY_PREFIX}gmock${CMAKE_STATIC_LIBRARY_SUFFIX} Threads::Threads)
 target_link_libraries(gmock INTERFACE optimized ${binary_dir}/lib/${RELEASE_DIR}${CMAKE_STATIC_LIBRARY_PREFIX}gmock${CMAKE_STATIC_LIBRARY_SUFFIX} Threads::Threads)
 target_link_libraries(gmock INTERFACE gtest)
 target_include_directories(gmock SYSTEM INTERFACE ${GTEST_INCLUDE_DIR} ${GMOCK_INCLUDE_DIR})
 add_dependencies(gmock googletest)
 
 add_library(gmock_main INTERFACE)
-target_link_libraries(gmock_main INTERFACE debug ${binary_dir}/lib/${DEBUG_DIR}${CMAKE_STATIC_LIBRARY_PREFIX}gmock_main${DEBUG_LIB_SUFFIX}${CMAKE_STATIC_LIBRARY_SUFFIX} Threads::Threads)
+target_link_libraries(gmock_main INTERFACE debug ${binary_dir}/lib/${DEBUG_DIR}${CMAKE_STATIC_LIBRARY_PREFIX}gmock_main${CMAKE_STATIC_LIBRARY_SUFFIX} Threads::Threads)
 target_link_libraries(gmock_main INTERFACE optimized ${binary_dir}/lib/${RELEASE_DIR}${CMAKE_STATIC_LIBRARY_PREFIX}gmock_main${CMAKE_STATIC_LIBRARY_SUFFIX} Threads::Threads)
 target_link_libraries(gmock_main INTERFACE gmock)
 target_include_directories(gmock_main SYSTEM INTERFACE ${GTEST_INCLUDE_DIR} ${GMOCK_INCLUDE_DIR})

=== deps/json/CMakeLists.txt ===
include(GNUInstallDirs)

install(
    FILES json.hpp
    DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR}/yaramod/json/
)

=== deps/pog/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(pog
	LANGUAGES CXX
	VERSION 0.5.2
)

## Module path for custom finders.
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

## Options.
option(POG_BUNDLED_RE2  "Use bundled re2"                   OFF)
option(POG_BUNDLED_FMT  "Use bundled fmt"                   OFF)
option(POG_EXAMPLES     "Build examples"                    OFF)
option(POG_TESTS        "Build tests"                       OFF)
option(POG_COVERAGE     "Enable coverage"                   OFF)
option(POG_PIC          "Enable position independent code"  OFF)

## Includes.
include(CMakePackageConfigHelpers)
include(GNUInstallDirs)

## Require C++17 support.
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

## Variables.
set(POG_INCLUDE_DIR          "${CMAKE_CURRENT_SOURCE_DIR}/include")
set(POG_INSTALL_CMAKE_DIR    "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATADIR}/cmake/pog")
set(POG_INSTALL_LIB_DIR      "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
set(POG_INSTALL_INCLUDE_DIR  "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR}")
set(POG_CMAKE_CONFIG_FILE_IN "${CMAKE_CURRENT_SOURCE_DIR}/share/pog-config.cmake.in")
set(POG_CMAKE_CONFIG_FILE    "${CMAKE_CURRENT_BINARY_DIR}/share/pog-config.cmake")
set(POG_CMAKE_VERSION_FILE   "${CMAKE_CURRENT_BINARY_DIR}/share/pog-config-version.cmake")
set(POG_PC_CONFIG_FILE_IN    "${CMAKE_CURRENT_SOURCE_DIR}/share/pog.pc.in")
set(POG_PC_CONFIG_FILE       "${CMAKE_CURRENT_BINARY_DIR}/share/pog.pc")
set(POG_CMAKE_INSTALL_FILES  "${POG_CMAKE_CONFIG_FILE}" "${POG_CMAKE_VERSION_FILE}")
set(POG_PC_INSTALL_FILES     "${POG_PC_CONFIG_FILE}")

## Requirements
### Threads - because of RE2
find_package(Threads REQUIRED)

## If bundled RE2 is not being used, try to find it using find_package().
if(NOT POG_BUNDLED_RE2)
	find_package(re2 REQUIRED)
	if(RE2_FOUND)
		message(STATUS "RE2 include directory: ${RE2_INCLUDE_DIR}")
		message(STATUS "RE2 library: ${RE2_LIBRARY}")
	endif()
	## Install our custom finder in case user system does not contain one.
	list(APPEND POG_CMAKE_INSTALL_FILES "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Findre2.cmake")
endif()

## If bundled fmt is not being used, try to find it using find_package().
if(NOT POG_BUNDLED_FMT)
	find_package(fmt REQUIRED)
	if(fmt_FOUND)
		message(STATUS "Found libfmt")
	endif()
else()
	## Install our custom finder in case user system does not contain one.
	list(APPEND POG_CMAKE_INSTALL_FILES "${CMAKE_CURRENT_SOURCE_DIR}/cmake/fmt/Findfmt.cmake")
endif()

## Add deps folder to resolve bundled dependencies.
add_subdirectory(deps)

## Library.
add_library(pog INTERFACE)
target_sources(pog INTERFACE ${POG_FILES})
if(MSVC)
	target_compile_options(pog INTERFACE /W3)
else()
	target_compile_options(pog INTERFACE -Wall -Wextra -Wno-empty-body)
endif()
target_include_directories(pog INTERFACE
	"$<BUILD_INTERFACE:${POG_INCLUDE_DIR}>"
	"$<INSTALL_INTERFACE:${POG_INSTALL_INCLUDE_DIR}>"
)
target_link_libraries(pog INTERFACE re2::re2 fmt::fmt)
if(POG_COVERAGE)
	target_compile_options(pog INTERFACE --coverage)
	target_link_libraries(pog INTERFACE --coverage)
endif()

## Build examples if requested.
if(POG_EXAMPLES)
	add_subdirectory(examples)
endif()

## Build tests if requested.
if(POG_TESTS)
	add_subdirectory(tests)
endif()

## We need to set custom RE2 include directory and library path if bundled dependencies are used.
## Also we need to set proper requirements for pkg-config file.
if(POG_BUNDLED_RE2)
	set(RE2_INCLUDE_DIR "${POG_INSTALL_INCLUDE_DIR}/pog")
	set(RE2_LIBRARY "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/${CMAKE_STATIC_LIBRARY_PREFIX}pog_re2${CMAKE_STATIC_LIBRARY_SUFFIX}")
	set(POG_PC_REQUIREMENT "Libs: -L\$\{libdir\} -lpog_re2 -lpthread")
else()
	set(RE2_INCLUDE_DIR "<NOT_SET>")
	set(RE2_LIBRARY "<NOT_SET>")
	set(POG_PC_REQUIREMENT "Requires: re2\nLibs: -L\$\{libdir\}")
endif()

## Handle also fmt in pkg-config file.
if(POG_BUNDLED_FMT)
	set(FMT_INCLUDE_DIR "${POG_INSTALL_INCLUDE_DIR}/pog")
	set(FMT_LIBRARY "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}//${CMAKE_STATIC_LIBRARY_PREFIX}pog_fmt${CMAKE_STATIC_LIBRARY_SUFFIX}")
	set(POG_PC_REQUIREMENT "${POG_PC_REQUIREMENT} -lpog_fmt")
else()
	set(FMT_INCLUDE_DIR "<NOT_SET>")
	set(FMT_LIBRARY "<NOT_SET>")
	set(POG_PC_REQUIREMENT "${POG_PC_REQUIREMENT} -lfmt")
endif()

## Create pog-config.cmake
configure_package_config_file(
	${POG_CMAKE_CONFIG_FILE_IN}
	${POG_CMAKE_CONFIG_FILE}
	INSTALL_DESTINATION ${POG_INSTALL_CMAKE_DIR}
	PATH_VARS
		RE2_INCLUDE_DIR RE2_LIBRARY
		FMT_INCLUDE_DIR FMT_LIBRARY
)

## Create pog-config-version.cmake
write_basic_package_version_file(
	${POG_CMAKE_VERSION_FILE}
	VERSION ${PROJECT_VERSION}
	COMPATIBILITY AnyNewerVersion
)

## Create pog.pc
configure_file(
	${POG_PC_CONFIG_FILE_IN}
	${POG_PC_CONFIG_FILE}
	@ONLY
)

## Install.
### Include directory.
install(
	DIRECTORY ${POG_INCLUDE_DIR}/pog
	DESTINATION ${POG_INSTALL_INCLUDE_DIR}
)

### Export pog::pog target into pog-targets.cmake
install(TARGETS pog EXPORT pog)
install(
	EXPORT pog
	FILE pog-targets.cmake
	NAMESPACE pog::
	DESTINATION ${POG_INSTALL_CMAKE_DIR}
)

### Install CMake related files (cmake-config.cmake, cmake-config-version.cmake)
install(
	FILES ${POG_CMAKE_INSTALL_FILES}
	DESTINATION ${POG_INSTALL_CMAKE_DIR}
)

### Install pkg-config related files (pog.pc)
install(
	FILES ${POG_PC_CONFIG_FILE}
	DESTINATION ${POG_INSTALL_LIB_DIR}/pkgconfig
)

=== docs/rtd/requirements.txt ===
Sphinx>=4.3.0
sphinx_rtd_theme>=0.4.3
sphinx-tabs>=1.1.13

=== tests/cpp/CMakeLists.txt ===
--- 
+++ 
@@ -10,6 +10,8 @@
 	parser_tests.cpp
 	trie_tests.cpp
 	utils_tests.cpp
+	visitor_tests.cpp
+	yara_file_tests.cpp
 	yaramod_tests.cpp
 )

=== src/examples/cpp/CMakeLists.txt ===
add_subdirectory(dump_rules_ast)
add_subdirectory(simplify_bools)

=== deps/pog/deps/fmt/CMakeLists.txt ===
--- 
+++ 
@@ -1,17 +1,26 @@
 include(GNUInstallDirs)
 include(ExternalProject)
+include(ProcessorCount)
+
+ProcessorCount(CPUS)
 
 set(FMT_INSTALL_DIR             ${CMAKE_CURRENT_BINARY_DIR}/fmt)
+# CMake 3.23+ puts CMAKE_LIBRARY_ARCHITECTURE into CMAKE_INSTALL_LIBDIR only if /usr/ is in CMAKE_INSTALL_PREFIX so we need to manually fix it
+if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.23.0" AND CMAKE_INSTALL_LIBDIR MATCHES "/${CMAKE_LIBRARY_ARCHITECTURE}$")
+	string(REGEX REPLACE "/${CMAKE_LIBRARY_ARCHITECTURE}$" "/" FMT_INSTALL_LIBDIR ${FMT_INSTALL_DIR}/${CMAKE_INSTALL_LIBDIR})
+else()
+	set(FMT_INSTALL_LIBDIR ${FMT_INSTALL_DIR}/${CMAKE_INSTALL_LIBDIR})
+endif()
 set(FMT_INCLUDE_DIR             ${FMT_INSTALL_DIR}/include)
-set(FMT_INSTALLED_LIBRARY       ${FMT_INSTALL_DIR}/${CMAKE_INSTALL_LIBDIR}/${CMAKE_STATIC_LIBRARY_PREFIX}fmt${CMAKE_STATIC_LIBRARY_SUFFIX})
-set(FMT_INSTALLED_LIBRARY_DEBUG ${FMT_INSTALL_DIR}/${CMAKE_INSTALL_LIBDIR}/${CMAKE_STATIC_LIBRARY_PREFIX}fmtd${CMAKE_STATIC_LIBRARY_SUFFIX})
-set(FMT_LIBRARY                 ${FMT_INSTALL_DIR}/${CMAKE_INSTALL_LIBDIR}/${CMAKE_STATIC_LIBRARY_PREFIX}pog_fmt${CMAKE_STATIC_LIBRARY_SUFFIX})
+set(FMT_INSTALLED_LIBRARY       ${FMT_INSTALL_LIBDIR}/${CMAKE_STATIC_LIBRARY_PREFIX}fmt${CMAKE_STATIC_LIBRARY_SUFFIX})
+set(FMT_INSTALLED_LIBRARY_DEBUG ${FMT_INSTALL_LIBDIR}/${CMAKE_STATIC_LIBRARY_PREFIX}fmtd${CMAKE_STATIC_LIBRARY_SUFFIX})
+set(FMT_LIBRARY                 ${FMT_INSTALL_LIBDIR}/${CMAKE_STATIC_LIBRARY_PREFIX}pog_fmt${CMAKE_STATIC_LIBRARY_SUFFIX})
 
 if(MSVC)
 	set(FMT_BUILD_COMMAND ${CMAKE_COMMAND} --build . --config $<CONFIG> -- -m)
 	set(FMT_INSTALL_COMMAND ${CMAKE_COMMAND} --build . --target install --config $<CONFIG>)
 else()
-	set(FMT_BUILD_COMMAND ${CMAKE_COMMAND} --build . -- -j)
+	set(FMT_BUILD_COMMAND ${CMAKE_COMMAND} --build . -- -j${CPUS})
 	set(FMT_INSTALL_COMMAND ${CMAKE_COMMAND} --build . --target install)
 endif()
 
@@ -24,6 +33,7 @@
 		-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}
 		-DCMAKE_CXX_FLAGS=${CMAKE_CXX_FLAGS}
 		-DCMAKE_CXX_FLAGS_RELEASE=${CMAKE_CXX_FLAGS_RELEASE}
+		-DCMAKE_CXX_FLAGS_DEBUG=${CMAKE_CXX_FLAGS_DEBUG}
 		-DCMAKE_POSITION_INDEPENDENT_CODE=${POG_PIC}
 		-DFMT_TEST=OFF
 		-DFMT_DOC=OFF

=== deps/pog/deps/re2/CMakeLists.txt ===
--- 
+++ 
@@ -1,17 +1,24 @@
 include(ExternalProject)
+include(GNUInstallDirs)
+include(ProcessorCount)
 
-include(GNUInstallDirs)
+ProcessorCount(CPUS)
 
 set(RE2_INSTALL_DIR       ${CMAKE_CURRENT_BINARY_DIR}/re2)
+if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.23.0" AND CMAKE_INSTALL_LIBDIR MATCHES "/${CMAKE_LIBRARY_ARCHITECTURE}$")
+	string(REGEX REPLACE "/${CMAKE_LIBRARY_ARCHITECTURE}$" "/" RE2_INSTALL_LIBDIR ${RE2_INSTALL_DIR}/${CMAKE_INSTALL_LIBDIR})
+else()
+	set(RE2_INSTALL_LIBDIR ${RE2_INSTALL_DIR}/${CMAKE_INSTALL_LIBDIR})
+endif()
 set(RE2_INCLUDE_DIR       ${RE2_INSTALL_DIR}/include)
-set(RE2_INSTALLED_LIBRARY ${RE2_INSTALL_DIR}/${CMAKE_INSTALL_LIBDIR}/${CMAKE_STATIC_LIBRARY_PREFIX}re2${CMAKE_STATIC_LIBRARY_SUFFIX})
-set(RE2_LIBRARY           ${RE2_INSTALL_DIR}/${CMAKE_INSTALL_LIBDIR}/${CMAKE_STATIC_LIBRARY_PREFIX}pog_re2${CMAKE_STATIC_LIBRARY_SUFFIX})
+set(RE2_INSTALLED_LIBRARY ${RE2_INSTALL_LIBDIR}/${CMAKE_STATIC_LIBRARY_PREFIX}re2${CMAKE_STATIC_LIBRARY_SUFFIX})
+set(RE2_LIBRARY           ${RE2_INSTALL_LIBDIR}/${CMAKE_STATIC_LIBRARY_PREFIX}pog_re2${CMAKE_STATIC_LIBRARY_SUFFIX})
 
 if(MSVC)
 	set(RE2_BUILD_COMMAND ${CMAKE_COMMAND} --build . --config $<CONFIG> -- -m)
 	set(RE2_INSTALL_COMMAND ${CMAKE_COMMAND} --build . --target install --config $<CONFIG>)
 else()
-	set(RE2_BUILD_COMMAND ${CMAKE_COMMAND} --build . -- -j)
+	set(RE2_BUILD_COMMAND ${CMAKE_COMMAND} --build . -- -j${CPUS})
 	set(RE2_INSTALL_COMMAND ${CMAKE_COMMAND} --build . --target install)
 endif()
 
@@ -25,6 +32,7 @@
 		-DCMAKE_BUILD_TYPE=Release
 		-DCMAKE_CXX_FLAGS=${CMAKE_CXX_FLAGS}
 		-DCMAKE_CXX_FLAGS_RELEASE=${CMAKE_CXX_FLAGS_RELEASE}
+		-DCMAKE_CXX_FLAGS_DEBUG=${CMAKE_CXX_FLAGS_DEBUG}
 		-DRE2_BUILD_TESTING=OFF
 	BUILD_COMMAND
 		${RE2_BUILD_COMMAND}

=== debian/changelog ===
yaramod (3.21.0-1.1build2) questing; urgency=medium

  * Rebuild against latest abseil

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 04 May 2025 08:20:34 -0400

yaramod (3.21.0-1.1build1) plucky; urgency=medium

  * No-change rebuild for Python 3.13 as the default.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 03 Jan 2025 11:57:08 +0100

yaramod (3.21.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Trigger rebuild against Python 3.12 as the default version.
  * debian/tests/unittest.sh: Bump hardcoded YARAMOD_VERSION to 3.21.0.

 -- Boyuan Yang <byang@debian.org>  Wed, 03 Jul 2024 17:18:46 -0400

yaramod (3.21.0-1) unstable; urgency=medium

  * New upstream release
    * Fix FTBFS (Closes: #1037908)
  * Bump Standards-Version to 4.7.0

 -- Yangfl <mmyangfl@gmail.com>  Tue, 28 May 2024 02:25:45 +0800

yaramod (3.6.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Patch: Support setuptools >= 60 (Closes: #1022534)

 -- Stefano Rivera <stefanor@debian.org>  Sun, 13 Nov 2022 10:21:29 +0200

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%yaramod-$1.tar.gz%" \
   https://github.com/avast/yaramod/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
